PAGE,132
        .RADIX  16
_TEXT   SEGMENT PARA    PUBLIC  'CODE'
        ORG     100h
        ASSUME  CS:_TEXT,DS:_TEXT,ES:_TEXT

START:  CALL    INIT            ; Initialization
        INT     21h             ; Do it.
        JC      ERROR_EXIT      ; Exit with ERRORLEVEL if carry set.
        MOV     CX,AX           ; Set loop counter.
        JCXZ    EXIT            ; Handle zero-byte file.
        MOV     BP,DS:[100h]    ; Maximum stacking in command.
        LEA     BX,MESSAGE_NUMBER; Pointer to MESSAGE_NUMBER buffer.
INIT_LOOP:
        MOV     DS:[BX],"TR"    ; Store "RT" into start of buffer.
        INC     BX              ; \
        INC     BX              ; / Point BX at next available byte.
BYTE_LOOP:
        LODSB                   ; Get a byte.
        CMP     AL,30h          ; \
        JB      M_LOOP          ;  \ Do nothing if
        CMP     AL,39h          ;  / not numeric.
        JBE     NUMERIC         ; /
M_LOOP: LOOP    BYTE_LOOP       ; Try again.

EXIT:   MOV     AX,0A0Dh        ; \
        STOSW                   ; / Add <CRLF>.
        MOV     AH,40h          ; Request write-to-filehandle service.
        MOV     BX,0001h        ; STDOUT.
        MOV     CX,DI                ; \
        SUB     CX,OFFSET DATA_BUFFER; / Number of bytes to write.
        INT     21h             ; Do it.
        JC      ERROR_EXIT      ; Handle any flagged errors.
        CMP     AX,CX           ; Is bytes-written what it should be ?
        JNE     NOT_ENOUGH_DISC_SPACE; If not, you're probably looking
                                ; at insufficient disc space.
        MOV     AX,4C00h        ; \
        INT     21h             ; / Exit with ERRORLEVEL = 0.

NOT_ENOUGH_DISC_SPACE:
        MOV     AH,40h                      ; \
        MOV     BX,2                        ;  \  If insufficient disk
        LEA     CX,MESSAGE_NUMBER           ;   \ space, complain via
        SUB     CX,OFFSET NOT_ENOUGH_SPACE  ;   / the STDERR filehandle.
        LEA     DX,NOT_ENOUGH_SPACE         ;  /
        INT     21H                         ; /

        MOV     AL,0FFh         ; \ Set up strange ERRORLEVEL for
                                ; / insufficient disc space.
ERROR_EXIT:
        MOV     AH,4Ch
        INT     21h

NUMERIC: MOV    DS:[BX],AL      ; Otherwise store 1st digit of message number.
        INC     BX              ; Increment pointer.
        DEC     CX              ; Decrement number of bytes remaining.
        LODSB                   ; Get a byte.
        DEC     CX              ; Decrement number of bytes remaining.
        CMP     AL,30h          ; \
        JB      NUM_LOOP        ;  \ If byte is non-numeric, number is
        CMP     AL,39h          ;  / finished, so write it out.
        JA      NUM_LOOP        ; /
        MOV     DS:[BX],AL      ; Otherwise store 2nd digit of message number.
        INC     BX              ; Increment pointer.
        LODSB                   ; Get a byte.
        DEC     CX              ; Decrement number of bytes remaining.
        CMP     AL,30h          ; \
        JB      NUM_LOOP        ;  \ If byte is non-numeric, number is
        CMP     AL,39h          ;  / finished, so write it out.
        JA      NUM_LOOP        ; /
        MOV     DS:[BX],AL      ; Otherwise store 3rd digit of message number.
        INC     BX              ; Increment pointer.
        LODSB                   ; Get a byte.
        DEC     CX              ; Decrement number of bytes remaining.
        CMP     AL,30h          ; \
        JB      NUM_LOOP        ;  \ If byte is non-numeric, number is
        CMP     AL,39h          ;  / finished, so write it out.
        JA      NUM_LOOP        ; /
        MOV     DS:[BX],AL      ; Otherwise store 4th digit of message number.
        INC     BX              ; Increment pointer.
        LODSB                   ; Get a byte.
        DEC     CX              ; Decrement number of bytes remaining.
        CMP     AL,30h          ; \
        JB      NUM_LOOP        ;  \ If byte is non-numeric, number is
        CMP     AL,39h          ;  / finished, so write it out.
        JA      NUM_LOOP        ; /
        MOV     DS:[BX],AL      ; Otherwise store 5th digit of message number.
        INC     BX              ; Increment pointer.
        LODSB                   ; Get a byte.
        DEC     CX              ; Decrement number of bytes remaining.
        CMP     AL,30h          ; \
        JB      NUM_LOOP        ;  \ If byte is non-numeric, number is
        CMP     AL,39h          ;  / finished, so write it out.
        JA      NUM_LOOP        ; /
        MOV     DS:[BX],AL      ; Otherwise store 1st digit of message number.
        INC     BX              ; Increment pointer.
        LODSB                   ; Get a byte.
        DEC     CX              ; Decrement number of bytes remaining.
        CMP     AL,30h          ; \
        JB      NUM_LOOP        ;  \ If byte is non-numeric, number is
        CMP     AL,39h          ;  / finished, so write it out.
        JA      NUM_LOOP        ; /
        MOV     DS:[BX],AL      ; Otherwise store 6th digit of message number.
        INC     BX              ; Increment pointer.
                                ; Can't be any longer. Write it out.

NUM_LOOP:
        MOV     WORD PTR DS:[BX],'NO'; \
        INC     BX                   ;  \ Add on 'ONL' trailer
        INC     BX                   ;  /
        MOV     BYTE PTR DS:[BX],'L' ; /
        INC     BX                   ; Update for count of bytes to copy.
        PUSH    SI              ; Save SI register. (DATA_BUFFER source)
        LEA     SI,MESSAGE_NUMBER; Point at start of MESSAGE_NUMBER buffer.
        PUSH    CX              ; Save CX register. (Bytes left to parse)
        MOV     CX,BX           ; Copy BX to CX.
        SUB     CX,OFFSET MESSAGE_NUMBER; Number of digits to print.
        SUB     BP,CX           ; Number of bytes left after this copy.
        JNC     NOT_EOL         ; If not negative don't
                                ; execute end-of-line routine.
        MOV     AX,0A0Dh        ; \ Pass <CRLF> to buffer.
        STOSW                   ; /
        INC     SI              ; Don't copy leading semi-colon.
        DEC     CX              ; So reduce copy-counter by one.
        MOV     BP,DS:[100h]    ; Re-initialize BP.
        SUB     BP,CX           ; But there will already be CX bytes.
NOT_EOL:
        REP     MOVSB           ; Copy command to line.
        POP     CX              ; \
        POP     SI              ; / Restore registers.
        LEA     BX,MESSAGE_NUMBER   ; Pointer to MESSAGE_NUMBER buffer.
        MOV     BYTE PTR DS:[BX],';'; Semi-colon separator.
        INC     BX                  ; Point to next available byte.
        JMP     NEAR PTR INIT_LOOP  ; Top of loop.

NOT_ENOUGH_SPACE DB 0Dh,0Ah,7
        DB      'Insufficient disk space to write output file.',0Dh,0Ah

MESSAGE_NUMBER  DB 0C DUP(?)    ; Store message number here temporarily.

DATA_BUFFER     DB ?            ; Data buffer begins here

;   The following initialization code is executed at startup, and can be
;safely overwritten thereafter.

INIT:   MOV     WORD PTR DS:[0100H],75h;
        LEA     SI,DATA_BUFFER  ; \ Point source and destination
        LEA     DI,DATA_BUFFER  ; / pointers at start of DATA_BUFFER.
        CLD                     ; Set string ops forward.
        MOV     WORD PTR DS:[00FEh],0; Clean up top of new stack.
        POP     AX              ; Retrieve return address.
        MOV     SP,00FEh        ; Re-set stack pointer.
        PUSH    AX              ; Push return address to new stack.
        MOV     AH,4Ah          ; Modify memory-segment size request.
        PUSH    CS              ; \
        POP     ES              ; / Current program's segment.
        MOV     BX,1000h        ; 4096 paragraphs = 64 kbytes.
        INT     21h             ; Do it.
;PSEUDO JC      ERROR_EXIT      ; Punt if failure.
        JNC     $+5             ; Continue if succesful.
        JMP     NEAR PTR ERROR_EXIT; Punt if failure.
        LEA     DX,DATA_BUFFER  ; To/from DS:DATA_BUFFER
        MOV     AH,3Fh          ; Read-from-filehandle-service.
        MOV     BX,0000h        ; STDIN filehandle.
        MOV     CX,0F800h       ; 62 Kbytes
        RET                     ; Back to main program

_TEXT   ENDS
        END     START

